Project Chrono: chrono::sensor::ChRadarSensor Class Reference

Public Member Functions | List of all members
chrono::sensor::ChRadarSensor Class Reference
SENSOR module » Sensors

## Description

Radar Class/ This corresponds to a fmcw radar.

`#include <ChRadarSensor.h>`

Inheritance diagram for chrono::sensor::ChRadarSensor:
[legend]
Collaboration diagram for chrono::sensor::ChRadarSensor:
[legend]

## Public Member Functions
| ChRadarSensor (std::shared_ptr< chrono::ChBody > parent, const float updateRate, chrono::ChFrame< double > offsetPose, const unsigned int w, const unsigned int h, const float hfov, const float vfov, const float max_distance, const float clip_near=1e-3f)
| Constructor for the base radar class.
| ~ChRadarSensor ()
| Class destructor.
float | GetHFOV () const
| Gives the horizontal field of view of the radar (angle between right-most and left-most ray for a "frame").
float | GetVFOV () const
| Returns the vertical field of view the radar.
float | GetMaxDistance () const
| Returns the maximum range of the radar.
float | GetClipNear () const
| Returns the near clipping distance.
ChVector3d | GetTranslationalVelocity ()
| Returns the translational velocity of the object the radar is attached to.
ChVector3d | GetAngularVelocity ()
| Returns the angular velocity of the object the radar is attached to.
Public Member Functions inherited from chrono::sensor::ChOptixSensor
| ChOptixSensor (std::shared_ptr< chrono::ChBody > parent, float updateRate, chrono::ChFrame< double > offsetPose, unsigned int w, unsigned int h)
| Constructor for the base camera class that defaults to a pinhole lens model.
virtual | ~ChOptixSensor ()
| camera class destructor
PipelineType | GetPipelineType ()
unsigned int | GetWidth ()
unsigned int | GetHeight ()
CUstream | GetCudaStream ()
Public Member Functions inherited from chrono::sensor::ChSensor
| ChSensor (std::shared_ptr< chrono::ChBody > parent, float updateRate, chrono::ChFrame< double > offsetPose)
| Constructor for the base sensor class.
virtual | ~ChSensor ()
| Class destructor.
void | SetOffsetPose (chrono::ChFrame< double > pose)
| Set the sensor's relative position and orientation.
ChFrame< double > | GetOffsetPose ()
| Get the sensor's relative position and orientation.
std::shared_ptr< ChBody > | GetParent () const
| Get the object to which the sensor is attached.
void | SetName (std::string name)
| Set the sensor's name.
std::string | GetName () const
| Get the name of the sensor.
float | GetUpdateRate () const
| Get the sensor update rate (Hz).
void | SetLag (float t)
| Set the lag parameter.
float | GetLag () const
| Get the sensor lag (seconds).
void | SetCollectionWindow (float t)
| Set the collection window.
float | GetCollectionWindow () const
| Get the sensor data collection window (seconds).
void | SetUpdateRate (float updateRate)
| Set the sensor update rate (Hz).
unsigned int | GetNumLaunches ()
| Get the number of times the sensor has been updated.
void | IncrementNumLaunches ()
| Increments the count of number of updates.
std::list< std::shared_ptr< ChFilter > > | GetFilterList () const
| Get the sensor's list of filters.
void | PushFilter (std::shared_ptr< ChFilter > filter)
| Add a filter to the sensor.
void | PushFilterFront (std::shared_ptr< ChFilter > filter)
| Add a filter to the front of the list on a sensor.
void | LockFilterList ()
| Gives ability to lock the filter list to prevent race conditions.
template<class UserBufferType>
UserBufferType | GetMostRecentBuffer ()
| Get the last filter in the list that matches the template type.
template<>
CH_SENSOR_API UserR8BufferPtr | GetMostRecentBuffer ()
template<>
CH_SENSOR_API UserRGBA8BufferPtr | GetMostRecentBuffer ()
template<>
CH_SENSOR_API UserDepthBufferPtr | GetMostRecentBuffer ()
template<>
CH_SENSOR_API UserDIBufferPtr | GetMostRecentBuffer ()
template<>
CH_SENSOR_API UserXYZIBufferPtr | GetMostRecentBuffer ()
template<>
CH_SENSOR_API UserRadarBufferPtr | GetMostRecentBuffer ()
template<>
CH_SENSOR_API UserRadarXYZBufferPtr | GetMostRecentBuffer ()
template<>
CH_SENSOR_API UserAccelBufferPtr | GetMostRecentBuffer ()
template<>
CH_SENSOR_API UserGyroBufferPtr | GetMostRecentBuffer ()
template<>
CH_SENSOR_API UserMagnetBufferPtr | GetMostRecentBuffer ()
template<>
CH_SENSOR_API UserGPSBufferPtr | GetMostRecentBuffer ()
template<>
CH_SENSOR_API UserTachometerBufferPtr | GetMostRecentBuffer ()

## Additional Inherited Members
Protected Attributes inherited from chrono::sensor::ChOptixSensor
PipelineType | m_pipeline_type
| the type of pipeline for rendering
Protected Attributes inherited from chrono::sensor::ChSensor
float | m_updateRate
| sensor update rate
float | m_lag
| sensor lag from the time all scene information is available (sensor processing time)
float | m_collection_window
| time over which data is collected.
float | m_timeLastUpdated
| time since previous update
std::shared_ptr< chrono::ChBody > | m_parent
| object to which the sensor is attached
chrono::ChFrame< double > | m_offsetPose
| position and orientation of the sensor relative to its parent
std::string | m_name
| name of the sensor
unsigned int | m_num_launches
| number of times the sensor has been updated
std::list< std::shared_ptr< ChFilter > > | m_filters
| filter list for post-processing sensor data
bool | m_filter_list_locked = false
| gives ability to lock the filter list to prevent race conditions

## Constructor & Destructor Documentation

## ◆ ChRadarSensor()

CH_SENSOR_API chrono::sensor::ChRadarSensor::ChRadarSensor | ( | std::shared_ptr< chrono::ChBody > | parent,
|  | const float | updateRate,
|  | chrono::ChFrame< double > | offsetPose,
|  | const unsigned int | w,
|  | const unsigned int | h,
|  | const float | hfov,
|  | const float | vfov,
|  | const float | max_distance,
|  | const float | clip_near = 1e-3f )

Constructor for the base radar class.

Parameters

  parent | Body to which the sensor is attached
  updateRate | the rate at which the sensor will be updated
  offsetPose | the relative mounting position of the sensor
  w | Width in number of samples of a radar scan
  h | Height in number of samples of a radar scan
  hfov | Horizontal field of view of the lidar
  vfov | vertical angle of the lidar
  max_distance | the farthest detectable distance for the radar
  clip_near | Near clipping distance so that lidar sensor can be easily placed inside a visualization object (sensor housing)

## Member Function Documentation

## ◆ GetAngularVelocity()

ChVector3d chrono::sensor::ChRadarSensor::GetAngularVelocity | ( |  | ) |
| inline

Returns the angular velocity of the object the radar is attached to.

Returns
  Returns the angular velocity of the object the radar is attached to

## ◆ GetClipNear()

float chrono::sensor::ChRadarSensor::GetClipNear | ( |  | ) | const
| inline

Returns the near clipping distance.

Returns
  the near clipping distance

## ◆ GetHFOV()

float chrono::sensor::ChRadarSensor::GetHFOV | ( |  | ) | const
| inline

Gives the horizontal field of view of the radar (angle between right-most and left-most ray for a "frame").

Horizontal field of view should be 360-(angular resulution) in degrees for a full 360 degree scanning radar.

Returns
  The horizontal field of view of the radar sensor

## ◆ GetMaxDistance()

float chrono::sensor::ChRadarSensor::GetMaxDistance | ( |  | ) | const
| inline

Returns the maximum range of the radar.

Returns
  The maximum distance for the radar

## ◆ GetTranslationalVelocity()

ChVector3d chrono::sensor::ChRadarSensor::GetTranslationalVelocity | ( |  | ) |
| inline

Returns the translational velocity of the object the radar is attached to.

Returns
  Returns the translational velocity of the object the radar is attached to

## ◆ GetVFOV()

float chrono::sensor::ChRadarSensor::GetVFOV | ( |  | ) | const
| inline

Returns the vertical field of view the radar.

Returns
  The vertical field of view the radar sensor

The documentation for this class was generated from the following files:

- D:/W/B/src/chrono-9.0.1/src/chrono_sensor/sensors/ChRadarSensor.h
- D:/W/B/src/chrono-9.0.1/src/chrono_sensor/sensors/ChRadarSensor.cpp